A - Prime Path(11.1.1)

来源:互联网 发布:mac卸载app怎么清理 编辑:程序博客网 时间:2024/04/29 23:26
A - Prime Path(11.1.1)
Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u
Submit Status

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

6

7

0

代码:

#include <iostream>#include <cstring>#include <cmath>#include <string>#include <cstdio>using namespace std;const int maxn=100000;const int maxs=11000;struct node{    int k,step;};node h[maxn];int s[maxs];bool a[maxs];void is_prime(){    memset(a,0,sizeof(a));    int k=sqrt(double(9999));    a[0]=1;    a[1]=1;    for(int i=2;i<=9999;i++)        if(!a[i])        for(int j=i*i;j<=9999;j+=i)        a[j]=1;}int change(int x,int i,int j){    if(i==1)        return (x/10)*10+j;    if(i==2)        return (x/100)*100+j*10+x%10;    if(i==3)        return (x/1000)*1000+x%100+j*100;    if(i==4)        return (x%1000)+j*1000;}int bfs(int x,int y){    is_prime();    h[1].k=x;    h[1].step=0;    int l,r,ans;    l=1;    r=1;    ans=-1;    memset(s,100,sizeof(s));    while(1)    {        if(h[l].k==y)        {            ans=h[l].step;            return ans;        }        int tk,ts;        for(int i=1;i<=4;i++)            for(int j=0;j<=9;j++)                if(!((j==0)&&(i==4)))               {                tk=change(h[l].k,i,j);                if(a[tk]) continue;                ts=h[l].step+1;                if(ts>=s[tk]) continue;                if(tk==y)                {                    ans=ts;                    return ans;                }                s[tk]=ts;                r++;                h[r].k=tk;                h[r].step=ts;               }            if(l==r||ans>=0)                return ans;            l++;        }       return ans;}int main(){    int t,x,y;    cin>>t;    while(t--)    {        int ans1;        cin>>x>>y;        ans1=bfs(x,y);        if(ans1>=0)cout<<ans1<<endl;elsecout<<"Impossible"<<endl;    }    return 0;}


0 0